
!StackInterpreter methodsFor: '*ExperimentalBitCogVMMaker' stamp: 'MarianoMartinezPeck 12/21/2011 11:57'!
primitiveGetExperimentalBit
	| rcvr hdr |
	rcvr := self stackTop.
	(self isIntegerObject: rcvr)
		ifTrue:
			[self primitiveFail ]
		ifFalse:
			[ self pop: 1.  "we only pop the receiver"
			self pushBool: (objectMemory getExperimentalBitOf: rcvr) ~= 0]
		! !

!StackInterpreter methodsFor: '*ExperimentalBitCogVMMaker' stamp: 'MarianoMartinezPeck 12/21/2011 11:58'!
primitiveSetExperimentalBit
	| boolean rcvr hdr wasImmutable |
	rcvr := self stackValue: 1.
	(self isIntegerObject: rcvr) ifTrue:
		[^self primitiveFailFor: PrimErrInappropriate].
	boolean := self booleanValueOf: self stackTop.
	self successful ifFalse:
		[^self primitiveFailFor: PrimErrBadArgument].
	objectMemory setExperimentalBitOf: rcvr to: boolean.
	self pop: 1
! !

!StackInterpreter methodsFor: '*ExperimentalBitCogVMMaker' stamp: 'MarianoMartinezPeck 12/21/2011 12:00'!
primitiveTurnOffExperimentalBitOfAllObjects
	| oop |
	oop := self firstAccessibleObject.
	[oop = nil] whileFalse: [
		(self isIntegerObject:  oop)
			ifFalse: [ 
				objectMemory setExperimentalBitOf: oop to: false
				].
		oop := self accessibleObjectAfter: oop.
	].
	
	! !

!ObjectMemory methodsFor: '*ExperimentalBitCogVMMaker' stamp: 'MarianoMartinezPeck 12/21/2011 10:43'!
getExperimentalBitOf: anOop
	self inline: true.
	^((self baseHeader: anOop) bitAnd: ExperimentalObjectBit) ! !

!ObjectMemory methodsFor: '*ExperimentalBitCogVMMaker' stamp: 'MarianoMartinezPeck 12/21/2011 10:57'!
setExperimentalBitOf: anOop to: boolean
	| hdr |
	self inline: true.
	"Dont check here if it is integer. Check in the sender of this."
	hdr := self baseHeader: anOop.
	boolean 
		ifTrue: [ self baseHeader: anOop put: (hdr bitOr: ExperimentalObjectBit). ]
		ifFalse: [ self baseHeader: anOop put: (hdr bitAnd: AllButExperimentalBit). ]
! !
